#pragma once
#include <PSX/System/threads.hpp>

namespace JabyEngine {
    namespace [[deprecated("Callbacks are deprecated for now")]] Callback {
        namespace internal {
            namespace VSync {
                static constexpr size_t StackSize = 64;

                extern SysCall::ThreadHandle thread_handle;
                extern uint32_t              stack[StackSize];
                void                         routine();

                static void execute() {
                    MainThread::prepare_if_main(VSync::thread_handle);
                    Thread::execute_next();
                }
            }
        }
    }
}
