#include "../../internal-include/System/callbacks_internal.hpp"
#include <PSX/System/callbacks.hpp>

namespace JabyEngine {
    namespace Callback {
        VSyncCallback::Function VSyncCallback :: callback = nullptr;

        namespace internal {
            namespace VSync {
                SysCall::ThreadHandle thread_handle    = 0;
                uint32_t              stack[StackSize] = {0};

                void routine() {
                    while(true) {
                        if(VSyncCallback::callback) {
                            VSyncCallback::callback();
                        }
                        SysCall::EnterCriticalSection();
                        MainThread::restore();
                    }
                }
            }
        }
    }
}