#pragma once
#include "syscalls.hpp"

namespace JabyEngine {
    namespace [[deprecated("Callbacks are deprecated for now")]] Callback {
        struct VSyncCallback {
            using Function = void (*)();
            
            static Function callback;

            static void install(Function function) {
                VSyncCallback::callback = function;
            }

            static void uninstall() {
                VSyncCallback::install(nullptr);
            }
        };
    }
}